VTK: vtkCylinder Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkCylinder Class Reference

implicit function for a cylinder More...

`#include <vtkCylinder.h>`

Inheritance diagram for vtkCylinder:
[legend]
Collaboration diagram for vtkCylinder:
[legend]

## Public Types
typedef vtkImplicitFunction | Superclass
Public Types inherited from vtkImplicitFunction
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkCylinder * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | EvaluateGradient (double x[3], double g[3]) override
| Evaluate cylinder function gradient. More...
double | EvaluateFunction (double x[3]) override
| Evaluate cylinder equation F(r) = r^2 - Radius^2. More...
virtual double | EvaluateFunction (double x[3])=0
| Evaluate cylinder equation F(r) = r^2 - Radius^2. More...
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
| Evaluate cylinder equation F(r) = r^2 - Radius^2. More...
virtual double | EvaluateFunction (double x, double y, double z)
| Evaluate cylinder equation F(r) = r^2 - Radius^2. More...
virtual void | SetRadius (double)
| Set/Get the cylinder radius. More...
virtual double | GetRadius ()
| Set/Get the cylinder radius. More...
virtual void | SetCenter (double, double, double)
| Set/Get the cylinder center. More...
virtual void | SetCenter (double[3])
| Set/Get the cylinder center. More...
virtual double * | GetCenter ()
| Set/Get the cylinder center. More...
virtual void | GetCenter (double &, double &, double &)
| Set/Get the cylinder center. More...
virtual void | GetCenter (double[3])
| Set/Get the cylinder center. More...
void | SetAxis (double ax, double ay, double az)
| Set/Get the axis of the cylinder. More...
void | SetAxis (double a[3])
| Set/Get the axis of the cylinder. More...
virtual double * | GetAxis ()
| Set/Get the axis of the cylinder. More...
virtual void | GetAxis (double &, double &, double &)
| Set/Get the axis of the cylinder. More...
virtual void | GetAxis (double[3])
| Set/Get the axis of the cylinder. More...
Public Member Functions inherited from vtkImplicitFunction
vtkImplicitFunction * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
vtkMTimeType | GetMTime () override
| Overload standard modified time function. More...
virtual void | FunctionValue (vtkDataArray *input, vtkDataArray *output)
| Evaluate function at position x-y-z and return value. More...
double | FunctionValue (const double x[3])
| Evaluate function at position x-y-z and return value. More...
double | FunctionValue (double x, double y, double z)
| Evaluate function at position x-y-z and return value. More...
void | FunctionGradient (const double x[3], double g[3])
| Evaluate function gradient at position x-y-z and pass back vector. More...
double * | FunctionGradient (const double x[3])
| Evaluate function gradient at position x-y-z and pass back vector. More...
double * | FunctionGradient (double x, double y, double z)
| Evaluate function gradient at position x-y-z and pass back vector. More...
virtual void | SetTransform (vtkAbstractTransform *)
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual void | SetTransform (const double elements[16])
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual vtkAbstractTransform * | GetTransform ()
| Set/Get a transformation to apply to input points before executing the implicit function. More...
virtual void | EvaluateFunction (vtkDataArray *input, vtkDataArray *output)
| Evaluate function at position x-y-z and return value. More...
virtual double | EvaluateFunction (double x, double y, double z)
| Evaluate function at position x-y-z and return value. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCylinder * | SafeDownCast (vtkObjectBase *o)
static vtkCylinder * | New ()
| Construct cylinder radius of 0.5; centered at origin with axis along y coordinate axis. More...
Static Public Member Functions inherited from vtkImplicitFunction
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImplicitFunction * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkCylinder ()
| ~vtkCylinder () override=default
Protected Member Functions inherited from vtkImplicitFunction
| vtkImplicitFunction ()
| ~vtkImplicitFunction () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
double | Radius
double | Center [3]
double | Axis [3]
Protected Attributes inherited from vtkImplicitFunction
vtkAbstractTransform * | Transform
double | ReturnValue [3]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

implicit function for a cylinder

vtkCylinder computes the implicit function and function gradient for a cylinder using F(r)=r^2-Radius^2. vtkCylinder is a concrete implementation of vtkImplicitFunction. By default the Cylinder is centered at the origin and the axis of rotation is along the y-axis. You can redefine the center and axis of rotation by setting the Center and Axis data members. (Note that it is also possible to use the superclass' vtkImplicitFunction transformation matrix if necessary to reposition by using FunctionValue() and FunctionGradient().)

Warning
  The cylinder is infinite in extent. To truncate the cylinder in modeling operations use the vtkImplicitBoolean in combination with clipping planes.

See also
  vtkCylinderSource

Online Examples:

Tests:
  vtkCylinder (Tests)

Definition at line 45 of file vtkCylinder.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkImplicitFunction vtkCylinder::Superclass

Definition at line 48 of file vtkCylinder.h.

## Constructor & Destructor Documentation

## ◆ vtkCylinder()

vtkCylinder::vtkCylinder | ( |  | ) |
| protected

## ◆ ~vtkCylinder()

vtkCylinder::~vtkCylinder | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkCylinder::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkCylinder::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkImplicitFunction.

## ◆ SafeDownCast()

static vtkCylinder* vtkCylinder::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkCylinder::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkImplicitFunction.

## ◆ NewInstance()

vtkCylinder* vtkCylinder::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkCylinder::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

## ◆ New()

static vtkCylinder* vtkCylinder::New | ( |  | ) |
| static

Construct cylinder radius of 0.5; centered at origin with axis along y coordinate axis.

## ◆ EvaluateFunction() [1/4]

double vtkCylinder::EvaluateFunction | ( | double | x[3] | ) |
| overridevirtual

Evaluate cylinder equation F(r) = r^2 - Radius^2.

Implements vtkImplicitFunction.

## ◆ EvaluateGradient()

void vtkCylinder::EvaluateGradient | ( | double | x[3],
|  | double | g[3]
| ) |  |
| overridevirtual

Evaluate cylinder function gradient.

Implements vtkImplicitFunction.

## ◆ SetRadius()

virtual void vtkCylinder::SetRadius | ( | double |  | ) |
| virtual

Set/Get the cylinder radius.

## ◆ GetRadius()

virtual double vtkCylinder::GetRadius | ( |  | ) |
| virtual

Set/Get the cylinder radius.

## ◆ SetCenter() [1/2]

virtual void vtkCylinder::SetCenter | ( | double | ,
|  | double | ,
|  | double |
| ) |  |
| virtual

Set/Get the cylinder center.

## ◆ SetCenter() [2/2]

virtual void vtkCylinder::SetCenter | ( | double | [3] | ) |
| virtual

Set/Get the cylinder center.

## ◆ GetCenter() [1/3]

virtual double* vtkCylinder::GetCenter | ( |  | ) |
| virtual

Set/Get the cylinder center.

## ◆ GetCenter() [2/3]

virtual void vtkCylinder::GetCenter | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the cylinder center.

## ◆ GetCenter() [3/3]

virtual void vtkCylinder::GetCenter | ( | double | [3] | ) |
| virtual

Set/Get the cylinder center.

## ◆ SetAxis() [1/2]

void vtkCylinder::SetAxis | ( | double | ax,
|  | double | ay,
|  | double | az
| ) |  |

Set/Get the axis of the cylinder.

If the axis is not specified as a unit vector, it will be normalized. If zero-length axis vector is used as input to this method, it will be ignored.

## ◆ SetAxis() [2/2]

void vtkCylinder::SetAxis | ( | double | a[3] | ) |

Set/Get the axis of the cylinder.

If the axis is not specified as a unit vector, it will be normalized. If zero-length axis vector is used as input to this method, it will be ignored.

## ◆ GetAxis() [1/3]

virtual double* vtkCylinder::GetAxis | ( |  | ) |
| virtual

Set/Get the axis of the cylinder.

If the axis is not specified as a unit vector, it will be normalized. If zero-length axis vector is used as input to this method, it will be ignored.

## ◆ GetAxis() [2/3]

virtual void vtkCylinder::GetAxis | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

Set/Get the axis of the cylinder.

If the axis is not specified as a unit vector, it will be normalized. If zero-length axis vector is used as input to this method, it will be ignored.

## ◆ GetAxis() [3/3]

virtual void vtkCylinder::GetAxis | ( | double | [3] | ) |
| virtual

Set/Get the axis of the cylinder.

If the axis is not specified as a unit vector, it will be normalized. If zero-length axis vector is used as input to this method, it will be ignored.

## ◆ EvaluateFunction() [2/4]

virtual double vtkImplicitFunction::EvaluateFunction

Evaluate cylinder equation F(r) = r^2 - Radius^2.

## ◆ EvaluateFunction() [3/4]

virtual void vtkImplicitFunction::EvaluateFunction

Evaluate cylinder equation F(r) = r^2 - Radius^2.

## ◆ EvaluateFunction() [4/4]

virtual double vtkImplicitFunction::EvaluateFunction
| inline

Evaluate cylinder equation F(r) = r^2 - Radius^2.

Definition at line 121 of file vtkImplicitFunction.h.

## Member Data Documentation

## ◆ Radius

double vtkCylinder::Radius
| protected

Definition at line 101 of file vtkCylinder.h.

## ◆ Center

double vtkCylinder::Center[3]
| protected

Definition at line 102 of file vtkCylinder.h.

## ◆ Axis

double vtkCylinder::Axis[3]
| protected

Definition at line 103 of file vtkCylinder.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkCylinder.h